/* $Id: basic.h,v 1.5 1997/10/23 12:40:02 tony Exp $ */

/*------------------------------------------------------------
 * basic.h
 *
 * Basic macros and definitions.
 *------------------------------------------------------------
 */

/* **********************************************************************
 *
 * Copywrited by Anthony B Gialluca,
 *  $Date: 1997/10/23 12:40:02 $, All rights reserved.
 *
 * **********************************************************************
 */


/*
    License

    This file is part of ipclassify.

    ipclassify is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ipclassify is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ipclassify.  If not, see <http://www.gnu.org/licenses/>.
*/



#ifndef	_BASICH
#define	_BASICH

#ifdef __cplusplus
extern "C" {
#endif
  
  
/* ----- Includes ----------------------------------------------------- */
  
#include <stdio.h>
#include <stdlib.h>

/* -------------------------------------------------------------------- */

/* ----- Defines ------------------------------------------------------ */

/* TRUE and FALSE get defined so many times, */
/* let's not get in the way of other definitions. */
#if     !defined(TRUE) || ((TRUE) != 1)
#define TRUE    (1)
#endif

#if     !defined(FALSE) || ((FALSE) != 0)
#define FALSE   (0)
#endif

#if     !defined(ERR) || ((ERR) != -1)
#define ERR     (-1)
#endif

#if     !defined(OK) || ((OK) != 0)
#define OK      (0)
#endif

#if     !defined(NOOK) || ((NOOK) != 1)
#define NOOK      (1)
#endif

#if     !defined(SUCCESS) || ((SUCCESS) != 1)
#define SUCCESS    (1)
#endif

#if     !defined(FAILURE) || ((FAILURE) != 0)
#define FAILURE   (0)
#endif

#if     !defined(EXIT_FAILURE) || ((EXIT_FAILURE) != 1)
#define EXIT_FAILURE    (1)
#endif

#if     !defined(EXIT_SUCCESS) || ((EXIT_SUCCESS) != 0)
#define EXIT_SUCCESS   (0)
#endif

/* Some boolean defines */
#ifndef bool
#define bool int
#endif
#define bool_not(b)       ((b) ? FALSE : TRUE)
#define bool_equal(a,b)   ((a) ? (b) : !(b))
#define bool_compare(a,b) ((a) ? ((b) ? 0 : 1) : ((b) ? -1 : 0))
#define bool_fromInt(i)   (((i) != 0) ? TRUE : FALSE)
#define bool_toInt(b)     ((b) ? 1 : 0)


/* The following defines are used to simplify bit handling. */

#define bit_mask1(i)	(1u << i)
#define bit_mask0(i)	-(1u << i)

#define bit_set(n,i)	((n) | bit_mask1(i))
#define bit_reset(n,i)	((n) & bit_mask0(i))
#define bit_toggle(n,i)	((n) ^ bit_mask1(i))
#define bit_test(n,i)	!!((n) & bit_mask1(i))

#define nbits(x)	(sizeof(x) * CHAR_BIT)

#ifdef __cplusplus
}
#endif

#endif  /* _BASICH */
